;
;       Compute inverse plank function for IR channels
;
function brtemp, freq, rad

@parameter_definition

;
;   Both input are scalars
;
    if (size(freq))[0] eq 0 and (size(rad))[0] eq 0 then begin
       if freq gt 500 then begin
          if rad gt 0 then begin
             tb = PLCON2*freq/alog(1.0+PLCON1*freq*freq*freq/rad)
          endif else begin
             tb = rad
          endelse
       endif else begin;             Microwave channels
          tb  = rad
       endelse
       return, tb
    endif
;
;   freq is a scalar, but rad is a vector
;
    if (size(freq))[0] eq 0 and (size(rad))[0] gt 0 then begin
       if freq gt 500 then begin
          tb = rad
          indx = where ( rad gt 0, cnt )
          if cnt gt 0 then begin
             tb[indx] = PLCON2*freq/alog(1.0+PLCON1*freq*freq*freq/rad[indx])
          endif else begin
             return, -1
          endelse
       endif else begin;             Microwave channels
          tb  = rad
       endelse
       return, tb
    endif
;
;   freq is a vector, and rad is a vector
;
    if (size(freq))[0] gt 0 and (size(rad))[0] gt 0 then begin
       if (size(freq))[(size(freq))[0]+2] ne (size(rad))[(size(rad))[0]+2] then begin
          print, 'brtemp: size of arrays do not match'
          help, freq
          help, rad
          return, -1
       endif
       tb = rad
       indx = where ( rad gt 0 and freq gt 500, cnt )
       if cnt gt 0 then begin
          tb[indx] = PLCON2*freq[indx]/alog(1.0+PLCON1*freq[indx]*freq[indx]*freq[indx]/rad[indx])
       endif else begin
           return, -1
       endelse
       return, tb
    endif
;
;   freq is a vector, but rad is a scalar
;
    if (size(freq))[0] gt 0 and (size(rad))[0] eq 0 then begin
       tb = rad
       indx = where ( freq gt 500, cnt )
       if cnt gt 0 then begin
          tb[indx] = PLCON2*freq[indx]/alog(1.0+PLCON1*freq[indx]*freq[indx]*freq[indx]/rad)
       endif else begin
          return, -1
       endelse
       return, tb
    endif

end
