FUNCTION separate_elements,string_in

  ; routine to separate elements within a line that are delimited by one 
  ;   or more blank spaces
  ; string_in = input string
  ; returned value is a string array (scalar if no characters on the line)
  ; written and tested, 98nov04, FPMills
  ; revised to handle lines that have no characters on them, 99apr05, FPMills

  ; remove blank spaces at beginning and end of line and compress 
  ;   blank spaces within the line into a single blank space
  ; add a blank space at end of line so the search routine will work properly
  strng = Strtrim(Strcompress(string_in),2)+" "
  strng_length = Strlen(strng)
  search_pos1 = 0
  strng_elements = ""
  While (search_pos1 LT (strng_length-1)) Do Begin
    ; look for next occurrence of a blank space
    search_pos2=Strpos(strng," ",search_pos1+1)
    ; add intervening substring to string array
    strng_elements=[strng_elements,$
                    Strmid(strng,search_pos1,(search_pos2-search_pos1))]
    ; set starting point for next search 
    search_pos1=search_pos2+1
  EndWhile

  ; remove dummy element at the beginning of the string array
  If (N_elements(strng_elements) GT 1) Then Begin
    strng_elements = strng_elements(1:n_elements(strng_elements)-1)
  EndIf Else Begin
    strng_elements = ""
  EndElse

RETURN,strng_elements

END
